/* Generated by GOB (v2.0.15)   (do not edit directly) */

#include <glib.h>
#include <glib-object.h>
#ifndef __STUFFKEEPER_DATA_ITEM_SEARCH_H__
#define __STUFFKEEPER_DATA_ITEM_SEARCH_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */



#include <glib.h>
#include <glib/gi18n.h>
#include <sqlite3.h>
#include <glib/gstdio.h>
#include <config.h>

#include "stuffkeeper-data-tag.h"
#include "stuffkeeper-data-item.h"
#include "stuffkeeper-data-schema.h"



typedef enum _SearchType {
    SEARCH_TYPE_NONE = 0,
    SEARCH_TYPE_IS = 1,
    SEARCH_TYPE_IS_NOT = 2,
    SEARCH_TYPE_CONTAINS = 3,
    SEARCH_TYPE_NOT_CONTAINS = 4,
    SEARCH_TYPE_NUM_ITEMS = 5
}SearchType;


typedef enum _SearchFieldType {
    SEARCH_TITLE            = 0,
    SEARCH_FIELD_SCHEMA     = 1,
    SEARCH_FIELD_TAG        = 2,
    SEARCH_FIELD_TITLE      = 3,
    SEARCH_FIELD_VALUE      = 4,
    NUM_SEARCH_FIELD        = 5
}SearchFieldType;

typedef struct _SearchField
{
    int id;
    int field_id;
    SearchFieldType field_type;
    SearchType type;
    char *value;
}SearchField;



/*
 * Type checking and casting macros
 */
#define STUFFKEEPER_TYPE_DATA_ITEM_SEARCH	(stuffkeeper_data_item_search_get_type())
#define STUFFKEEPER_DATA_ITEM_SEARCH(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), stuffkeeper_data_item_search_get_type(), StuffKeeperDataItemSearch)
#define STUFFKEEPER_DATA_ITEM_SEARCH_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), stuffkeeper_data_item_search_get_type(), StuffKeeperDataItemSearch const)
#define STUFFKEEPER_DATA_ITEM_SEARCH_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), stuffkeeper_data_item_search_get_type(), StuffKeeperDataItemSearchClass)
#define STUFFKEEPER_IS_DATA_ITEM_SEARCH(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), stuffkeeper_data_item_search_get_type ())

#define STUFFKEEPER_DATA_ITEM_SEARCH_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), stuffkeeper_data_item_search_get_type(), StuffKeeperDataItemSearchClass)

/* Private structure type */
typedef struct _StuffKeeperDataItemSearchPrivate StuffKeeperDataItemSearchPrivate;

/*
 * Main object structure
 */
#ifndef __TYPEDEF_STUFFKEEPER_DATA_ITEM_SEARCH__
#define __TYPEDEF_STUFFKEEPER_DATA_ITEM_SEARCH__
typedef struct _StuffKeeperDataItemSearch StuffKeeperDataItemSearch;
#endif
struct _StuffKeeperDataItemSearch {
	GObject __parent__;
	/*< private >*/
	StuffKeeperDataItemSearchPrivate *_priv;
};

/*
 * Class definition
 */
typedef struct _StuffKeeperDataItemSearchClass StuffKeeperDataItemSearchClass;
struct _StuffKeeperDataItemSearchClass {
	GObjectClass __parent__;
	/*signal*/void (* search_changed) (StuffKeeperDataItemSearch * self, const SearchField * field);
};


/*
 * Public methods
 */
GType	stuffkeeper_data_item_search_get_type	(void);
void 	stuffkeeper_data_item_search_search_changed	(StuffKeeperDataItemSearch * self,
					const SearchField * field);
void 	stuffkeeper_data_item_search_set_string	(StuffKeeperDataItemSearch * self,
					int searchtype,
					int fieldtype,
					const gchar * title);
GObject * 	stuffkeeper_data_item_search_new_dummy	(void);
GObject * 	stuffkeeper_data_item_search_open_from_id	(GObject * skdb,
					sqlite3 * sqlHandle,
					gint id);
StuffKeeperDataItemSearch * 	stuffkeeper_data_item_search_new	(GObject * skdb,
					sqlite3 * sqlHandle);
void 	stuffkeeper_data_item_search_free_search_field	(SearchField * field);
int 	stuffkeeper_data_item_search_match	(StuffKeeperDataItemSearch * self,
					StuffKeeperDataItem * item);
GList * 	stuffkeeper_data_item_search_get_search_fields	(StuffKeeperDataItemSearch * self);
void 	stuffkeeper_data_item_search_edit_search_field	(StuffKeeperDataItemSearch * self,
					SearchField * field);
void 	stuffkeeper_data_item_search_remove_search_field	(StuffKeeperDataItemSearch * self,
					SearchField * field);
SearchField * 	stuffkeeper_data_item_search_new_search_field	(StuffKeeperDataItemSearch * self,
					SearchType searchtype,
					SearchFieldType fieldtype,
					const gchar * value);
char * 	stuffkeeper_data_item_search_get_title	(StuffKeeperDataItemSearch * self);
void 	stuffkeeper_data_item_search_set_title	(StuffKeeperDataItemSearch * self,
					const char * title);
int 	stuffkeeper_data_item_search_get_id	(StuffKeeperDataItemSearch * self);
void 	stuffkeeper_data_item_search_delete_yourself	(StuffKeeperDataItemSearch * self);
void 	stuffkeeper_data_item_search_style_set	(StuffKeeperDataItemSearch * self,
					GtkStyle * style,
					GtkWidget * wid);
void 	stuffkeeper_data_item_search_search_title_changed	(StuffKeeperDataItemSearch * self,
					GtkWidget * entry);
void 	stuffkeeper_data_item_search_add_field	(StuffKeeperDataItemSearch * self,
					GtkWidget * button);
void 	stuffkeeper_data_item_search_remove_field	(StuffKeeperDataItemSearch * self,
					GtkWidget * button);
void 	stuffkeeper_data_item_search_edit_search_gui	(StuffKeeperDataItemSearch * self);

/*
 * Signal connection wrapper macros
 */
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define stuffkeeper_data_item_search_connect__search_changed(object,func,data)	g_signal_connect(STUFFKEEPER_DATA_ITEM_SEARCH(__extension__ ({StuffKeeperDataItemSearch *___object = (object); ___object; })),"search_changed",(GCallback) __extension__ ({void (* ___search_changed) (StuffKeeperDataItemSearch * ___fake___self, const SearchField * ___fake___field, gpointer ___data ) = (func); ___search_changed; }), (data))
#define stuffkeeper_data_item_search_connect_after__search_changed(object,func,data)	g_signal_connect_after(STUFFKEEPER_DATA_ITEM_SEARCH(__extension__ ({StuffKeeperDataItemSearch *___object = (object); ___object; })),"search_changed",(GCallback) __extension__ ({void (* ___search_changed) (StuffKeeperDataItemSearch * ___fake___self, const SearchField * ___fake___field, gpointer ___data ) = (func); ___search_changed; }), (data))
#define stuffkeeper_data_item_search_connect_data__search_changed(object,func,data,destroy_data,flags)	g_signal_connect_data(STUFFKEEPER_DATA_ITEM_SEARCH(__extension__ ({StuffKeeperDataItemSearch *___object = (object); ___object; })),"search_changed",(GCallback) __extension__ ({void (* ___search_changed) (StuffKeeperDataItemSearch * ___fake___self, const SearchField * ___fake___field, gpointer ___data ) = (func); ___search_changed; }), (data), (destroy_data), (GConnectFlags)(flags))
#else /* __GNUC__ && !__STRICT_ANSI__ */
#define stuffkeeper_data_item_search_connect__search_changed(object,func,data)	g_signal_connect(STUFFKEEPER_DATA_ITEM_SEARCH(object),"search_changed",(GCallback)(func),(data))
#define stuffkeeper_data_item_search_connect_after__search_changed(object,func,data)	g_signal_connect_after(STUFFKEEPER_DATA_ITEM_SEARCH(object),"search_changed",(GCallback)(func),(data))
#define stuffkeeper_data_item_search_connect_data__search_changed(object,func,data,destroy_data,flags)	g_signal_connect_data(STUFFKEEPER_DATA_ITEM_SEARCH(object),"search_changed",(GCallback)(func),(data),(destroy_data),(GConnectFlags)(flags))
#endif /* __GNUC__ && !__STRICT_ANSI__ */


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
