/* Generated by GOB (v2.0.15)   (do not edit directly) */

#include <glib.h>
#include <glib-object.h>
#ifndef __STUFFKEEPER_DATA_ITEM_H__
#define __STUFFKEEPER_DATA_ITEM_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */



#include <sqlite3.h>
#include "stuffkeeper-data-tag.h"
#include "stuffkeeper-data-schema.h"

        typedef enum _DbItemType {
            DB_ITEMS_TYPE_ID = 1,
            DB_ITEMS_TYPE_SCHEMA = 2,
            DB_ITEMS_TYPE_MTIME = 3,
            DB_ITEMS_TYPE_CTIME = 4,
            DB_ITEMS_TYPE_TAG = 5,
            DB_ITEMS_TYPE_NAME = 6,
            DB_ITEMS_TYPE_NAME_GENERATED_CACHE = 7

        }DbItemType;
        typedef enum _DbItemFieldType {
            DB_ITEMS_FIELD_TYPE_ID = 1,
            DB_ITEMS_FIELD_TYPE_TYPE = 3,
            DB_ITEMS_FIELD_TYPE_NAME = 4
        }DbItemFieldType;



/*
 * Type checking and casting macros
 */
#define STUFFKEEPER_TYPE_DATA_ITEM	(stuffkeeper_data_item_get_type())
#define STUFFKEEPER_DATA_ITEM(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), stuffkeeper_data_item_get_type(), StuffKeeperDataItem)
#define STUFFKEEPER_DATA_ITEM_CONST(obj)	G_TYPE_CHECK_INSTANCE_CAST((obj), stuffkeeper_data_item_get_type(), StuffKeeperDataItem const)
#define STUFFKEEPER_DATA_ITEM_CLASS(klass)	G_TYPE_CHECK_CLASS_CAST((klass), stuffkeeper_data_item_get_type(), StuffKeeperDataItemClass)
#define STUFFKEEPER_IS_DATA_ITEM(obj)	G_TYPE_CHECK_INSTANCE_TYPE((obj), stuffkeeper_data_item_get_type ())

#define STUFFKEEPER_DATA_ITEM_GET_CLASS(obj)	G_TYPE_INSTANCE_GET_CLASS((obj), stuffkeeper_data_item_get_type(), StuffKeeperDataItemClass)

/* Private structure type */
typedef struct _StuffKeeperDataItemPrivate StuffKeeperDataItemPrivate;

/*
 * Main object structure
 */
#ifndef __TYPEDEF_STUFFKEEPER_DATA_ITEM__
#define __TYPEDEF_STUFFKEEPER_DATA_ITEM__
typedef struct _StuffKeeperDataItem StuffKeeperDataItem;
#endif
struct _StuffKeeperDataItem {
	GObject __parent__;
	/*< private >*/
	StuffKeeperDataItemPrivate *_priv;
};

/*
 * Class definition
 */
typedef struct _StuffKeeperDataItemClass StuffKeeperDataItemClass;
struct _StuffKeeperDataItemClass {
	GObjectClass __parent__;
	/*signal*/void (* item_changed) (StuffKeeperDataItem * self, const gchar * field);
	/*signal*/void (* item_tags_changed) (StuffKeeperDataItem * self);
};


/*
 * Public methods
 */
GType	stuffkeeper_data_item_get_type	(void);
void 	stuffkeeper_data_item_item_changed	(StuffKeeperDataItem * self,
					const gchar * field);
void 	stuffkeeper_data_item_save_yourself	(StuffKeeperDataItem * self);
void 	stuffkeeper_data_item_delete_yourself	(StuffKeeperDataItem * self);
StuffKeeperDataItem * 	stuffkeeper_data_item_new	(GObject * skdb,
					sqlite3 * sqlHandle,
					StuffKeeperDataSchema * schema);
StuffKeeperDataItem * 	stuffkeeper_data_item_open_from_id	(GObject * skdb,
					sqlite3 * sqlHandle,
					gint id,
					gint schemaid);
int 	stuffkeeper_data_item_has_generated_title	(StuffKeeperDataItem * self);
gint 	stuffkeeper_data_item_get_id	(StuffKeeperDataItem * self);
void 	stuffkeeper_data_item_set_title	(StuffKeeperDataItem * self,
					const gchar * title);
gchar * 	stuffkeeper_data_item_get_title	(StuffKeeperDataItem * self);
gint 	stuffkeeper_data_item_get_creation_time	(StuffKeeperDataItem * self);
gint 	stuffkeeper_data_item_get_modification_time	(StuffKeeperDataItem * self);
gchar * 	stuffkeeper_data_item_get_string	(StuffKeeperDataItem * self,
					const char * field);
void 	stuffkeeper_data_item_set_string	(StuffKeeperDataItem * self,
					const gchar * id,
					const gchar * title);
gboolean 	stuffkeeper_data_item_get_integer_real	(StuffKeeperDataItem * self,
					const char * field,
					int * out);
int 	stuffkeeper_data_item_get_integer	(StuffKeeperDataItem * self,
					const char * field);
void 	stuffkeeper_data_item_set_integer	(StuffKeeperDataItem * self,
					const gchar * id,
					const int title);
gint 	stuffkeeper_data_item_get_boolean	(StuffKeeperDataItem * self,
					const gchar * field);
void 	stuffkeeper_data_item_set_boolean	(StuffKeeperDataItem * self,
					const gchar * field,
					const gint value);
gchar ** 	stuffkeeper_data_item_get_list	(StuffKeeperDataItem * self,
					const gchar * field,
					gsize * size);
void 	stuffkeeper_data_item_set_list	(StuffKeeperDataItem * self,
					const gchar * field,
					const gchar ** value,
					gsize length);
gboolean 	stuffkeeper_data_item_has_tag	(StuffKeeperDataItem * self,
					const StuffKeeperDataTag * tag);
void 	stuffkeeper_data_item_add_tag	(StuffKeeperDataItem * self,
					StuffKeeperDataTag * tag);
void 	stuffkeeper_data_item_remove_tag	(StuffKeeperDataItem * self,
					StuffKeeperDataTag * tag);
GList * 	stuffkeeper_data_item_get_tags	(StuffKeeperDataItem * self);
StuffKeeperDataSchema * 	stuffkeeper_data_item_get_schema	(StuffKeeperDataItem * self);
gboolean 	stuffkeeper_data_item_has_value_exact	(StuffKeeperDataItem * self,
					const gchar * value);
gboolean 	stuffkeeper_data_item_has_value	(StuffKeeperDataItem * self,
					const gchar * value);
GObject * 	stuffkeeper_data_item_get_backend	(StuffKeeperDataItem * self);

/*
 * Signal connection wrapper macros
 */
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define stuffkeeper_data_item_connect__item_changed(object,func,data)	g_signal_connect(STUFFKEEPER_DATA_ITEM(__extension__ ({StuffKeeperDataItem *___object = (object); ___object; })),"item_changed",(GCallback) __extension__ ({void (* ___item_changed) (StuffKeeperDataItem * ___fake___self, const gchar * ___fake___field, gpointer ___data ) = (func); ___item_changed; }), (data))
#define stuffkeeper_data_item_connect_after__item_changed(object,func,data)	g_signal_connect_after(STUFFKEEPER_DATA_ITEM(__extension__ ({StuffKeeperDataItem *___object = (object); ___object; })),"item_changed",(GCallback) __extension__ ({void (* ___item_changed) (StuffKeeperDataItem * ___fake___self, const gchar * ___fake___field, gpointer ___data ) = (func); ___item_changed; }), (data))
#define stuffkeeper_data_item_connect_data__item_changed(object,func,data,destroy_data,flags)	g_signal_connect_data(STUFFKEEPER_DATA_ITEM(__extension__ ({StuffKeeperDataItem *___object = (object); ___object; })),"item_changed",(GCallback) __extension__ ({void (* ___item_changed) (StuffKeeperDataItem * ___fake___self, const gchar * ___fake___field, gpointer ___data ) = (func); ___item_changed; }), (data), (destroy_data), (GConnectFlags)(flags))
#define stuffkeeper_data_item_connect__item_tags_changed(object,func,data)	g_signal_connect(STUFFKEEPER_DATA_ITEM(__extension__ ({StuffKeeperDataItem *___object = (object); ___object; })),"item_tags_changed",(GCallback) __extension__ ({void (* ___item_tags_changed) (StuffKeeperDataItem * ___fake___self, gpointer ___data ) = (func); ___item_tags_changed; }), (data))
#define stuffkeeper_data_item_connect_after__item_tags_changed(object,func,data)	g_signal_connect_after(STUFFKEEPER_DATA_ITEM(__extension__ ({StuffKeeperDataItem *___object = (object); ___object; })),"item_tags_changed",(GCallback) __extension__ ({void (* ___item_tags_changed) (StuffKeeperDataItem * ___fake___self, gpointer ___data ) = (func); ___item_tags_changed; }), (data))
#define stuffkeeper_data_item_connect_data__item_tags_changed(object,func,data,destroy_data,flags)	g_signal_connect_data(STUFFKEEPER_DATA_ITEM(__extension__ ({StuffKeeperDataItem *___object = (object); ___object; })),"item_tags_changed",(GCallback) __extension__ ({void (* ___item_tags_changed) (StuffKeeperDataItem * ___fake___self, gpointer ___data ) = (func); ___item_tags_changed; }), (data), (destroy_data), (GConnectFlags)(flags))
#else /* __GNUC__ && !__STRICT_ANSI__ */
#define stuffkeeper_data_item_connect__item_changed(object,func,data)	g_signal_connect(STUFFKEEPER_DATA_ITEM(object),"item_changed",(GCallback)(func),(data))
#define stuffkeeper_data_item_connect_after__item_changed(object,func,data)	g_signal_connect_after(STUFFKEEPER_DATA_ITEM(object),"item_changed",(GCallback)(func),(data))
#define stuffkeeper_data_item_connect_data__item_changed(object,func,data,destroy_data,flags)	g_signal_connect_data(STUFFKEEPER_DATA_ITEM(object),"item_changed",(GCallback)(func),(data),(destroy_data),(GConnectFlags)(flags))
#define stuffkeeper_data_item_connect__item_tags_changed(object,func,data)	g_signal_connect(STUFFKEEPER_DATA_ITEM(object),"item_tags_changed",(GCallback)(func),(data))
#define stuffkeeper_data_item_connect_after__item_tags_changed(object,func,data)	g_signal_connect_after(STUFFKEEPER_DATA_ITEM(object),"item_tags_changed",(GCallback)(func),(data))
#define stuffkeeper_data_item_connect_data__item_tags_changed(object,func,data,destroy_data,flags)	g_signal_connect_data(STUFFKEEPER_DATA_ITEM(object),"item_tags_changed",(GCallback)(func),(data),(destroy_data),(GConnectFlags)(flags))
#endif /* __GNUC__ && !__STRICT_ANSI__ */


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
